var Plugin = (require('livescript-compiler/lib/livescript/Plugin')['__default__'] || require('livescript-compiler/lib/livescript/Plugin'));
(function(){
  var x$, transformTopLevelAwait, hasAwaitIn, slice$ = [].slice, arrayFrom$ = Array.from || function(x){return slice$.call(x);};
  exports['__default__'] = x$ = transformTopLevelAwait = Object.create(Plugin);
  x$.name = 'transform-top-level-await';
  x$.overrideOptions = true;
  x$.enable = function(){
    var Block, x$, originalCompileRoot, Self;
    Block = this.livescript.livescript.ast.Block;
    x$ = originalCompileRoot = Block.prototype.compileRoot;
    this.originalCompileRoot = x$;
    Self = this;
    Block.prototype.compileRoot = function(options){
      var isAsyncBlock, x$, result, idx;
      isAsyncBlock = hasAwaitIn(this);
      if (isAsyncBlock && Self.overrideOptions) {
        options.bare = false;
      }
      if (isAsyncBlock && options.bare === true) {
        throw Error("Top level code should be wrap in async function but compile option 'bare' is preventing it.");
      }
      x$ = result = originalCompileRoot.call.apply(originalCompileRoot, [this].concat(arrayFrom$(arguments)));
      idx = x$.children.indexOf('(function(){\n');
      if (isAsyncBlock) {
        x$.children[idx] = '(async function(){\n';
      }
      return x$;
    };
  };
  x$.disable = function(){
    this.livescript.ast.Block.prototype.compileRoot = this.originalCompileRoot;
  };;
  hasAwaitIn = function(block){
    var result, isAwait;
    result = null;
    isAwait = function(child, parent, name, index){
      if (child.op === 'await') {
        result = true;
      }
      return result;
    };
    block.traverseChildren(isAwait, false);
    return result != null ? result : false;
  };
}).call(this);

//# sourceMappingURL=plugin.js.map
